<?php
namespace Df\Util;

use Zeedhi\Framework\Session\Session;

class FileServerOld extends \Teknisa\ZeedhiBundle\Remote\FileUploader\StaticApiKeyProvider {

    const ORGANIZATION_ID = 'nrorg';

    protected $apiKeyMapping = array(
        "ORGANIZATION_ID" => "FILE_SERVER_API_KEY"
    );

    /** @var Session */
    protected $session;

    /**
     * StaticApiKeyProvider constructor.
     * @param Session $session
     * @param array   $apiKeyMapping
     * @param string  $sessionProperty
     */
    public function __construct(Session $session, array $apiKeyMapping, $sessionProperty = self::ORGANIZATION_ID) {
        $this->session = $session;
 
        $this->apiKeyMapping = $apiKeyMapping;
        $this->sessionProperty = $sessionProperty;
    }


    public function getFileUploaderApiKey() {
        $apiKey = null;
        $currOrgId = $this->session->get($this->sessionProperty);
        $userInfo = $this->session->get('LOGIN_USER_INFO');
        if($currOrgId!=1){
        //$apiKeyNew=$this->getToken($currOrgId)?$this->getToken($currOrgId):null;
        }
        
        if(isset($this->apiKeyMapping[$currOrgId])) {
            $apiKey =  $this->apiKeyMapping[$currOrgId];
        }

        if(!$apiKey) {
            $apiKey   = isset($userInfo["FILE_SERVER_API_KEY"]) ? $userInfo["FILE_SERVER_API_KEY"] : '';
        }
       
        //  if($apiKeyNew){
        //     $apiKey=$apiKeyNew;
        // }
        return $apiKey;
    }
    
    public function getToken($nrorg){
        $filter = array(
            "requestType" => "FilterData",
            "filter" => array( array(
            'name' => 'NRORG', 'operator' => '=', 'value' => $nrorg
        )));
        
        $config=\Teknisa\Libs\Util\Utilities::getLoginConfig();
        $apiKey =\Teknisa\Libs\Util\Utilities::callWebService(null, '/getOrgFileServerKey', $filter, 'fileServerKey', $config['loginClientSecret'], 'https://license.teknisa.com/backend/index.php');
        
        return $apiKey[0];
    }
    

}