
function Dfe22000_DetalhamentoNotasFiscaisManifestada_Controller(General, ScreenService, templateManager, Dfe22000_DetalhamentoNotasFiscaisManifestada_Service, ZhFilterPreferences, ZHPromise, metaDataFactory, eventEngine, MessageService) {
	
    
    var CDEMPRESA;
    var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
    
    
    this.verificaBusca = function(widget){
 	    if(widget.currentRow.DTINSNRNSU != "" && widget.currentRow.IDAMBIENTENFE != "" && widget.currentRow.NRINSJURIEST != "")
        getPesquisaNSU(widget);
    };
    
    
    this.empresaOnChange = (widget) => {
        let cnpj = widget.getField("NRINSJURIEST");
        let cnpjFilter = cnpj.dataSourceFilter.find(data => data.name === 'CDEMPRESA');
        
        if(widget.currentRow.CDEMPRESA) cnpjFilter.value = widget.currentRow.CDEMPRESA; 
        
        cnpj.readOnly = !widget.currentRow.CDEMPRESA;
        cnpj.setValue('');
        validaParamFilter(widget);
    };
    
	var validaParamFilter = function (widget){
        var dataAtual = moment().format('MM/YYYY');
        var rowFilter = {};
        rowFilter.DTINSNRNSU = dataAtual;
    
 	    
 	    General.callRestEngine("df#/crud/filial", "FilterData", [{name: "CDFILIAL", operator:"=", value: "FILIAL_LOGADA"}]).then((response) => {
 	        if(response.dataset.filial[0]) {
 	            rowFilter.CDFILIAL  = response.dataset.filial[0].CDFILIAL;
 	            rowFilter.NMFILIAL  = response.dataset.filial[0].NMFILIAL;
 	        }
 	        widget.currentRow.DTINSNRNSU = rowFilter.DTINSNRNSU;
            widget.currentRow.IDAMBIENTENFE = '1';
//            ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
//            ZhFilterPreferences.openFilterWidget(widget, rowFilter);
 	    });
    };
    
    var getDetalhamentoNfManifestadaWidget = function(){
        if(templateManager.container)
            return templateManager.container.getWidget('cabecalho');
    };
    var getPesquisaNSU = function(args) {
    	
        var pai        = getDetalhamentoNfManifestadaWidget();
        var currentRow = args.currentRow;
        var gridAmbiente = "detalhamento_notas_fiscais_manifestada";
        let rowNovoNSU = [];
        
        var row        = {NRORG: currentRow.NRORG, NRINSJURIEST: currentRow.NRINSJURIEST, IDAMBIENTENFE: currentRow.IDAMBIENTENFE, DTINSNRNSU: currentRow.DTINSNRNSU};
        
        General.callRestEngine("df_relatorios#/findNrNSU", "Row", row).then(success => {
            let nsuNfe = success.dataset.findNrNSU;
            
            nsuNfe.forEach(el => {
                let objNSU = {
                    CNPJEMIT: el.CNPJEMIT, 
                    RESLOC: el.RES_LOC, 
                    DOCLOC: el.DOC_LOC, 
                    CANCLOC: el.CANC, 
                    DTEMIS: el.DTEMIS, 
                    DTINC: el.DTINC, 
                    FORMEMIT: el.FORMEMIT, 
                    IDAMBIENTENFE: el.IDAMBIENTENFE, 
                    NRACESSONFE: el.NRACESSONFE, 
                    NRINSJURIEST: el.NRINSJURIEST, 
                    NRNUMNOTA: el.NRNUMNOTA, 
                    NRSER: el.NRSER, 
                    UFEMIT: el.SGESTADO};
                rowNovoNSU.push(objNSU);
            });
            
            
            let child = getDetalhamentoNfManifestadaWidget().container.getWidget('NSU');
            let NAME = getDetalhamentoNfManifestadaWidget().container.getWidget('NSU').label;
            child.dataSource.setData(rowNovoNSU);
            child.reload();
            pai.reload();
        });
    };
    
    this.getPesquisaNSUHistorico = function(args) {
    	
        var pai        = getDetalhamentoNfManifestadaWidget().container.getWidget('NSU');
        var currentRow = args.row;
        var gridAmbiente = "detalhamento_notas_fiscais_manifestada";
        let rowNovoNSU = [];
        
        var row        = {NRACESSONFE: currentRow.NRACESSONFE};
        
        General.callRestEngine("df_relatorios#/findHistNSU", "Row", row).then(success => {
            let nsuNfe = success.dataset.findHistNSU;
            
            nsuNfe.forEach(el => {
                let objNSU = {
                        CDOPERINCLUSAO: el.CDOPERINCLUSAO,
                        CDOPERULTATU: el.CDOPERULTATU,
                        CDSERVICO: el.CDSERVICO,
                        CDSTATUS: el.CDSTATUS,
                        DSMOTIVO: el.DSMOTIVO,
                        DSSERVICO: el.DSSERVICO,
                        DTINCLUSAO: el.DTINCLUSAO,
                        DTINSNRNSU: el.DTINSNRNSU,
                        DTRECBTO: el.DTRECBTO,
                        DTULTATU: el.DTULTATU,
                        DTUPDNRNSU: el.DTUPDNRNSU,
                        IDAMBIENTENFE: el.IDAMBIENTENFE,
                        IDATIVO: el.IDATIVO,
                        IDCONSULTADO: el.IDCONSULTADO,
                        IDNRNSUFALTANTE: el.IDNRNSUFALTANTE,
                        IDSTATUSNFE: el.IDSTATUSNFE,
                        NRACESSONFE: el.NRACESSONFE,
                        NRINSJURIEST: el.NRINSJURIEST,
                        NRNSU: el.NRNSU,
                        NRORG: el.NRORG,
                        NRORGINCLUSAO: el.NRORGINCLUSAO,
                        NRORGULTATU: el.NRORGULTATU,
                        NRPROTOCOLO: el.NRPROTOCOLO,
                        NRSEQSERVICO: el.NRSEQSERVICO
                    };
                rowNovoNSU.push(objNSU);
            });
            
            let child = getDetalhamentoNfManifestadaWidget().container.getWidget('NSU').container.getWidget('historico');
            let NAME = getDetalhamentoNfManifestadaWidget().container.getWidget('NSU').container.getWidget('historico').label;
            child.dataSource.setData(rowNovoNSU);
            child.reload();
            pai.reload();
        });
    };
    
    this.downloadArqXML = function(args){
        let row = args.owner.widget.currentRow;
        Dfe22000_DetalhamentoNotasFiscaisManifestada_Service.downloadArqXML(row).then(fileUri => {
            this.downloadArquivo(fileUri[0]);
        }, error => {
            console.error(error);
            
            if(typeof(error.data.error) === 'string') ScreenService.showMessage(error.data.error);
            else                                      MessageService.showMessageByCode('ERRO_GERAL');
        });
    };
    
    this.downloadArquivo = function(nmArquivo){
        window.open(window.serviceUrls.filter(function(x){return x.package == 'df';})[0].baseUrl+"/downloadArquivo?requestType=Row&row[DSARQUIVO]=" + nmArquivo);
    };
}


Configuration(function(ContextRegister) {
	ContextRegister.register('Dfe22000_DetalhamentoNotasFiscaisManifestada_Controller', Dfe22000_DetalhamentoNotasFiscaisManifestada_Controller);
});
